Index: channels/chan_sip.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_sip.c,v
retrieving revision 1.747
diff -u -r1.747 chan_sip.c
--- channels/chan_sip.c	30 May 2005 13:51:04 -0000	1.747
+++ channels/chan_sip.c	3 Jun 2005 14:14:48 -0000
@@ -274,6 +280,11 @@
 #define DEFAULT_REALM	"asterisk"
 static char global_realm[MAXHOSTNAMELEN] = DEFAULT_REALM; 	/* Default realm */
 static char regcontext[AST_MAX_EXTENSION] = "";		/* Context for auto-extensions */
+/*
+ * command to register for regcontext
+ */
+static char regcommand[AST_MAX_EXTENSION] = "";
+static char *regarg = NULL;
 
 /* Expire slowly */
 #define DEFAULT_EXPIRY 900
@@ -1259,12 +1288,12 @@
 {
 	char multi[256]="";
 	char *stringp, *ext;
 	if (!ast_strlen_zero(regcontext)) {
 		ast_copy_string(multi, ast_strlen_zero(peer->regexten) ? peer->name : peer->regexten, sizeof(multi));
 		stringp = multi;
 		while((ext = strsep(&stringp, "&"))) {
 			if (onoff)
-				ast_add_extension(regcontext, 1, ext, 1, NULL, NULL, "Noop", strdup(peer->name), free, channeltype);
+				ast_add_extension(regcontext, 1, ext, 1, NULL, NULL, regcommand, regarg, NULL, channeltype);
 			else
 				ast_context_remove_extension(regcontext, ext, 1, NULL);
 		}
@@ -10423,6 +10307,22 @@
 	return peer;
 }
 
+static void init_regcommand(const char *s)
+{
+	ast_copy_string(regcommand, s, sizeof(regcommand));
+	regarg = strchr(regcommand, '(');
+	if (regarg == NULL)
+		regarg = "";
+	else {
+		char *p;
+		*regarg++ = '\0';
+		p = strrchr(regarg, ')');
+		if (p)
+			*p = '\0';
+	}
+}
+
+
 /*--- reload_config: Re-read SIP.conf config file ---*/
 /*	This function reloads all config data, except for
 	active peers (with registrations). They will only
@@ -10444,6 +10344,7 @@
 	char iabuf[INET_ADDRSTRLEN];
 	struct ast_flags dummy;
 	
+	init_regcommand("Noop(${EXTEN})");
 	cfg = ast_config_load(config);
 
 	/* We *must* have a config file otherwise stop immediately */
@@ -10558,6 +10459,8 @@
 			ast_copy_string(global_musicclass, v->value, sizeof(global_musicclass));
 		} else if (!strcasecmp(v->name, "language")) {
 			ast_copy_string(default_language, v->value, sizeof(default_language));
+		} else if (!strcasecmp(v->name, "regcommand")) {
+			init_regcommand(v->value);
 		} else if (!strcasecmp(v->name, "regcontext")) {
 			ast_copy_string(regcontext, v->value, sizeof(regcontext));
 			/* Create context if it doesn't exist already */
